from amilib.Cheetah.Template import Template
from amilib.Cheetah.Compiler import Compiler
from amilib.Cheetah.NameMapper import NotFound

import imp
import os, sys
import types

import urllib

#Should be changed from outside
MODE = "deployment"
BASE_NS = {}

TEMPLATE_MEMO = {}
def compile_template(path, is_string=False, base=None):
    """
    path: The path of the template
    is_string: If the path is actually a Cheetah string that we want to compile
    base: If another tmpl file should be used a base that provides functions
    """
    if not is_string:
        last_modified = os.stat(path).st_mtime

    if not is_string and TEMPLATE_MEMO.has_key(path) and last_modified <= TEMPLATE_MEMO[path][1] and MODE == "deployment":
        return TEMPLATE_MEMO[path][0]
    else:
        text = []
        if is_string:
            text.append(path)
        else:
            text.append(open(path).read())

        if base:
            text.insert(0, open(base).read())

        c = Compiler(source="".join(text), mainClassName='GenTemplate')
        ns = {}
        exec str(c) in ns
        tempclass = ns.get("GenTemplate", None)
        if not is_string:
            TEMPLATE_MEMO[path] = (tempclass, last_modified)
        return tempclass


def render(path, ns={}, is_string=False, base=None):
    if type(ns) == types.DictType:
        ns.update(BASE_NS)
        ns = [ns]
    else:
        ns = BASE_NS

    try:
        t = "%s" % compile_template(path, is_string, base)(searchList=ns)
        return t
    except NotFound, e:
        msg = "%s in file '%s'" % (e, path)
        print "\nTEMPLATE ERROR\n%s\n%s\n" % ("="*22, msg)
        return msg
