import os

from amilib.amiweb import amiweb

from skeletonz.modules.plugin import GenericPlugin
from skeletonz.user_plugins import ListOption, TextOption
from skeletonz.server import getConfig, getFormatManager

from skeletonz import Site

PLUGINS_FOR_EXPORT = ['GoogleSearch']
URL = "%s/GSController/" % getConfig().BASE_URL

class GoogleSearch(GenericPlugin):
    NAME = "Google search"
    DESCRIPTION = "Add a google search box to you site that searches it."
    SYNTAX = [
        {'handler': 'googlesearch',
         'required_arguments': {'ident': 'The id (cx)'},
         'optional_arguments': {}
        }
      ]

    def __init__(self):
        getFormatManager().registerSLPlugin('googlesearch', self.handle)

    def addToController(self, rc):
        path = "%s/site_plugins/google_search/static" % os.getcwd()
        rc.addStaticPath("/static_plugin/google_search/", path)

        rc.root_obj.GSController = GSController()

    def handle(self, args, edit_mode, page_id):
        id = args['googlesearch']
        if id != '':
            if args.has_key('nopowered'):
                powered = False
            else:
                powered = True
            return True, getSearchBox(URL, id, powered)
        return ''


class GSController:

    @amiweb.expose
    def index(self, q, cx, cof, sa=''):
        if q == 'mailund er sej':
            return 'No matches found. But you may want to know a fact: amir er sej!'

        html = """%s""" % (getResultBox(cx, q))
        kw = {}
        kw['title'] = 'Google powered search'
        kw['content'] = html
        kw['edit_mode'] = False
        kw['host_page'] = 1
        kw['id'] = None
        kw['hidden'] = False
        kw['premission_type'] = 'Everyone'
        kw['no_cache'] = True
        page_obj = Site.PageDeco(kw)
        return page_obj.servePage()

def getSearchBox(url, cx, powered_by=False, size=135):
    d = {'cx': cx, 'url': url, 'size': size}
    if powered_by:
        d['image'] = '<img src="static_plugin/google_search/powered.png" alt="powered by Google" />'
    else:
        d['image'] = ''
    return """
  <!-- Google CSE Search Box Begins -->
  <form id="searchbox_%(cx)s" action="%(url)s" style="padding: 2px 0 2px 0; margin: 0">
    <input type="hidden" name="cx" value="%(cx)s" />
    <input name="q" type="text" style="width: %(size)spx" id="google_search" /><br />
    %(image)s
    <input type="hidden" name="cof" value="FORID:9" />
  </form>
  <!-- Google CSE Search Box Ends -->
  """ % d

def getResultBox(cx, q):
    html = '<iframe src="http://www.google.com/custom?cx=' + cx +'&q='+ q +'&hl=en&sa=Search&cof=AH%3Aleft%3BCX%3Aamix%252Edk%3BDIV%3A%23cccccc%3BFORID%3A11%3BGFNT%3A%23666666%3BL%3Ahttp%3A%2F%2Fwww%2Egoogle%2Ecom%2Fcoop%2Fimages%2Fgoogle_custom_search_sm%2Egif%3BLH%3A55%3BLP%3A1%3B&ad=w9&num=10&client=pub-8548903584149054" frameborder="0" width="630" height="1000"></iframe>'
    html += """
<script>
    document.getElementById('google_search').value = "%s";
</script>
    """ % q.replace('"', '\\"')
    return html
