from amilib import json
import skeletonz.plugins.wikipages.filter as wiki_filter
import Tables
from skeletonz.mylib import html_helpers
from skeletonz.server import getConfig

def getPersonelTableHTML(table, edit_mode):
    result_text = []
    if edit_mode:
        result_text.append('<div id="personnelTable_%s" class="PersonnelHolder">' % table.id)

    result_text.append('<div class="PersonnelPersons">')
    items = table.getAllItems()
    for item in items:
        try:
            json_data = json.read(item.json_data)
        except:
            json_data = ""
        result_text.append(Tables.TableItems.generateHTML(json_data, item.id, edit_mode))
    if len(items) == 0:
        result_text.append('<p class="CMS_NotCreated">No persons inserted.</p>')

    if edit_mode:
        add_link = html_helpers.createActionLink("Add new person", "%s/static_plugin/personnel/user_add.png" % getConfig().BASE_URL, "Personnel.addNewPerson(this)")
        sort_link = html_helpers.createActionLink("Sort table after lastname", "%s/static_plugin/personnel/user_sort.png" % getConfig().BASE_URL, "Personnel.sortTable(this)", )
        reset_link = html_helpers.createActionLink("Reset table", "%s/static_core/images/trash.png" % getConfig().BASE_URL, "Personnel.resetTable(this)", "CMS_link CMS_critical_link")

        result_text.append('<div class="action action_plugin"><small>Manage personnel table:</small> %s\n %s \n  %s</div>' % (add_link, sort_link, reset_link))
        result_text.append("</div>")

    result_text.append('</div>')
    return "\n".join(result_text)


def getPersonelTableHTMLView(name, edit_mode):
    table = Tables.Tables.getTableByName(name)

    if not table:
        table = Tables.Tables.insertTable(name)

    items = table.getAllItems()

    if len(items) == 0:
        return '<p class="CMS_NotCreated">No persons inserted.</p>'

    result_text = ["""<table cellpadding="2" class="cms_personnel_view">
    <tr>
      <th width="25%">Name</th>
      <th width="20%">Position</th>
      <th width="15%">E-mail</th>
      <th width="10%">Phone</th>
      <th width="7%">Office</th>
    </tr>"""]

    color = ""
    for item in items:
        if color == "":
            color = "E6F4FF"
        else:
            color = ""
        json_data = json.read(item.json_data)

        rep_text = "%s" % Tables.TableItemsView.generateHTML(json_data, item.id, table.id, color)
        result_text.append(rep_text)
    result_text.append("</table>")

    #Fill in the template with edit info
    return "".join(result_text)
