//Create list element
function addRow(tr, text) {
  var new_list_item = TD({'style': 'white-space: nowrap;'}, text);

  var td_mc = TD({'style': 'text-align: right; width: 100%;'}, "");
  td_mc.className = "TdMenuController";

  tr.appendChild(new_list_item); 
  tr.appendChild(td_mc); 
}

function createListSeparator() {
  var tr = TR();
  tr.className = "ListItem";
  ACN(tr, TD({'style': 'background-color: #555; width: 100%; height: 5px;', 'colspan': 2}));
  return tr;
}

function createListItem(item, only_text) {
  //only_td used on edit

  //Only for external
  var name = item.name;
  if(item.type == 'external') {
    name = SPAN({}, name, SPAN({'class': 'explain'}, ' [external]'));
  }
  var text = SPAN({'class': 'TEXT'}, name);

  if(only_text) {
    return text;
  }

  //New element
  var tr = TR();

  //Add childred
  addRow(tr, text);

  tr.json = item;
  tr.className = "ListItem";
  return tr;
}

function getTextCol() {
  return getElementsByTagAndClassName("td", null, current_element)[0];
}

function insertIntoList(item) {
  var menuitems = $("menuitems");

  //Update JS
  var name; //Name is actually just the representation...
  var new_list_item = createListItem(item);

  if(item.insert_in_top) {
    try {
      menuitems.insertBefore(new_list_item, menuitems.childNodes[0]);
    }
    catch(e) {
      menuitems.appendChild(new_list_item);
    }
  }
  else {
    appendChildNodes(menuitems, new_list_item);
  }

  checkEmpty();
  appendListItemActions();  
  var result = new Array(2);
  result[0] = item.id;
  result[1] = new_list_item;
  return result;
}

function checkEmpty() {
  var menuitems = $("menuitems");
  var count = getElementsByTagAndClassName("tr", "ListItem").length;

  var empty = getElementsByTagAndClassName("tr", "Empty")[0];
  if(count > 0) {
    if(isDefined(empty))
    hideElement(empty);
  }
  else {
    var tr = TR({'class': 'Empty'});
    addRow(tr, "There are no items");

    if(!empty)
      menuitems.appendChild(tr);
    else
      showElement(empty);
  }
}

function removeElementSaveMC(elm) {
  //Remove element and save menu controller
  var menu_controller = $('menu_controller');
  var saved = menu_controller.cloneNode(true);
  removeElement(elm);
  var container = $('container');
  container.appendChild(saved);
  attachActions();
}


function onSubmitEditItem() {
  var menuitems = $("menuitems");

  var new_elm = createListItem(current_element.json, true);

  replaceChildNodes(current_element.childNodes[0].childNodes[0], new_elm);
  appendListItemActions();
  
  //Do Ajax update
  var d = getRequest(edit_url);
  d.sendReq({'data': serializeJSON(current_element.json)});
}



function createEditForm(fn_onsubmit, elms) {
  var save = SPAN({'class': 'link'}, "Save");
  var form = FORM({'style': 'margin: 0; padding: 0;'});
  form.onsubmit = fn_onsubmit;
  save.onmousedown = fn_onsubmit;
  for(elm in elms)
    appendChildNodes(form, elms[elm]);
  appendChildNodes(form, save);
  return form;
}

//For simple item objects
function createSimpleForm(fn_onsubmit) {
  var value = current_element.json.name;
  var input = INPUT({'id': 'f_edit_name',
            'type': 'text', 
            'style': 'margin-right: 5px;',
            'value': value
            });
  var form = createEditForm(fn_onsubmit, [input]);
  return form;
}

//Replace the textbox with just text
function changeValuesSimple() {
  var inputs = getElementsByTagAndClassName("input", null, current_element);
  var f_edit_name = inputs[0].value;
  current_element.json.name = f_edit_name;
}

//For external type
function createExternalForm(fn_onsubmit) {
  var name = current_element.json.name;
  var url = current_element.json.url;

  var input_name = INPUT({'id': 'f_edit_name',
            'type': 'text', 
            'style': 'margin-right: 5px; width: 115px;',
            'value': name
            });

  var input_url = INPUT({'id': 'f_edit_url',
            'type': 'text', 
            'style': 'margin-right: 5px; width: 145px;',
            'value': url
            });
  
  var form = createEditForm(fn_onsubmit, [input_name, input_url]);
  return form;
}

//Replace the textbox with just text
function changeValuesExternal() {
  var inputs = getElementsByTagAndClassName("input", null, current_element);
  var f_edit_name = inputs[0].value;
  var f_edit_url = inputs[1].value;

  current_element.json.name = f_edit_name;
  current_element.json.url = f_edit_url;
}


function createEditBox() {
  var fn_change_values;
  var fn_onsubmit = function() {
      fn_change_values();
      onSubmitEditItem(); 
      return false;
    };

  if(current_element.json.type == 'external') {
    fn_change_values = changeValuesExternal;
    var form = createExternalForm(fn_onsubmit);
  }
  else {
    fn_change_values = changeValuesSimple;
    var form = createSimpleForm(fn_onsubmit);
  }

  return SPAN({'class':'TEXT'}, form);
}
