/****
Last Modified: 

 AmiBar - A very simple toolbar
   Copyright Amir Salihefendic 2006
 AUTHOR
   4mir Salihefendic (http://amix.dk) - amix@amix.dk
 VERSION
	 1.0
 LICENSE
  LGPL
 SITE
   http://amix.dk/projects/AmiBar
****/
function AmiBar(img_dir) {
  this.img_dir = img_dir;
  this.buttons = [];
}

AmiBar.prototype.setToolbarContainer = function(elm) {
  this.toolbar_cnt = AJS.getElement(elm);
}

AmiBar.prototype.appendButton = function(btn) {
  this.buttons.push(btn);
}

AmiBar.prototype.removeButton = function(index) {
  this.buttons.splice(index, 1);
}


AmiBar.prototype.appendSeparator = function() {
  var btn = new AmiBarButton();
  btn.separator = true;
  this.buttons.push(btn);
}

AmiBar.prototype.createPanel = function() {
  var panel = AJS.DIV({'class': 'amibar_panel'});
  return panel;
}

AmiBar.prototype.createButton = function(button) {
  if(button.separator)
    return AJS.SPAN({'class': 'amibar_separator'}, " ");

  var btn = AJS.SPAN({'class': 'amibar_button'});
  btn.onclick = button.on_click_action;
  btn.onmouseover = button.on_mover_action;
  btn.onmouseout = button.on_mout_action;
  btn.onmousemove = button.on_mmove_action;

  var img = AJS.IMG({'src': this.img_dir + button.img});
  btn.appendChild(img);

  return btn;
}

AmiBar.prototype.populateDiv = function() {
  var panel = this.createPanel();
  for(var i=0; i < this.buttons.length; i++) {
    var button = this.buttons[i];
    var spn_button = this.createButton(button);
    panel.appendChild(spn_button);
  }
  AJS.replaceChildNodes(this.toolbar_cnt, panel);
}


function AmiBarButton(name, img) {
  this.separator = false;
  this.name = name;
  this.img = img;
  this.on_mover_action = null;
  this.on_mout_action = null;
  this.on_mmove_action = null;
} 

AmiBarButton.prototype.setOnClick = function(func) { this.on_click_action = func; }
AmiBarButton.prototype.setOnMouseOver = function(func) { this.on_mover_action = func; }
AmiBarButton.prototype.setOnMouseOut = function(func) { this.on_mout_action = func; }
AmiBarButton.prototype.setOnMouseMove = function(func) { this.on_mmove_action = func; }
