var AmiFormat = {
  placeCursor: function(field, place_pos) {
    var len = field.value.length;
    field.focus();
    if(document.selection) {
      var range = field.createTextRange();
      range.collapse(true);
      range.move('character', place_pos);
      range.select();
    }
    else if(field.selectionStart || field.selectionStart == "0") {
      field.selectionStart = place_pos;
      field.selectionEnd = place_pos;
    }
    field.focus();
  },

  /***
    To indicate where to put the cursor use ~.
    dont_replace: bool, spec. if selected text should be replaced
    wrap_in: bool, spec. if current selected text should be wraped in
  ***/
  insertAtCursor: function(field, val, dont_replace, wrap_in) {
    //Find where the cursor should be placed
    cursor_at = val.indexOf("~");
    if(cursor_at == -1)
      cursor_at = val.length;
    val = val.replace('~', '');

    //IE support
    if (document.selection) {
      field.focus();
      sel = document.selection.createRange();
      var selected_text = sel.text;
      sel.text = val;

      var d = val.length - cursor_at;
      sel.moveStart('character', -d);
      sel.moveEnd('character', -d);
      sel.select();
      if(wrap_in)
        AmiFormat.insertAtCursor(field, selected_text);
    }
    //Gecko support
    else if (field.selectionStart || field.selectionStart == "0") {
      var old_scroll = field.scrollTop;
      var startPos = field.selectionStart;
      var endPos = field.selectionEnd;
      var selected_text = field.value.substring(startPos, endPos);
      
      if(dont_replace)
        startPos = endPos;

      cursor_at += startPos;
      field.value = field.value.substring(0, startPos) + val + field.value.substring(endPos, field.value.length);
      field.selectionStart = cursor_at;
      field.selectionEnd = cursor_at;
      field.scrollTop = old_scroll;

      if(wrap_in)
        AmiFormat.insertAtCursor(field, selected_text);
    }
    else
      field.value += val;
    field.focus();
  }
};
