var ab_shown = false;
var ab_current_element = null;

ActionBar = function() {
  this.buttons = {};
  this.bar = AJS.SPAN({'class': 'action_bar'});
  
  this.disabled = false;
  this.list_commander = null; //Set from list commander

  this.cached_buttons = {};
  AJS.bindMethods(this);
}

ActionBar.prototype = {
  addButtons: function(type) {
    type = this.getType(type);
    var btn;
    for(var i=1; i < arguments.length; i++) {
      btn = arguments[i];
      btn.action_bar = this;

      if(this.buttons[type])
        this.buttons[type].push(btn);
      else
        this.buttons[type] = [btn];
    }
  },

  changeButton: function(index, type, new_btn) {
    this.buttons[type][index] = new_btn;
    var r = new_btn.render();
    AJS.swapDOM(this.bar.childNodes[index], r);
    this.cached_buttons[type][index] = r;
  },

  getType: function(type) {
    if(type && type != '')
      return type;
    else
      return 'default';
  },

  setShown: function(bool) { ab_shown = bool; },
  isShown: function() { return ab_shown == true; },

  isDisabled: function() { return this.disabled == true; },
  setDisable: function(bool) { 
    this.disabled = bool; 
    if(this.disabled) {
      AJS.map(this.bar.childNodes, function(n) {
        n.className = n.className + " CMS_disabled";
      });
    }
    else {
      AJS.map(this.bar.childNodes, function(n) {
        n.className = n.className.replace(" CMS_disabled", "");
      });
    }
  },

  renderBar: function(type) {
    type = this.getType(type);
    AJS.RCN(this.bar, null);

    if(this.cached_buttons[type]) {
      AJS.map(this.cached_buttons[type], AJS.$b(function(btn) {
        AJS.ACN(this.bar, btn);
      }, this));
    }
    else {
      var buttons;
      buttons = this.buttons[type];

      var cached_buttons = [];
      AJS.map(buttons, AJS.$b(function(btn) {
        var r = btn.render();
        AJS.ACN(this.bar, r);
        cached_buttons.push(r);
      }, this));

      this.cached_buttons[type] = cached_buttons;
    }
  },

  appendBar: function(dom_elm) {
    if(!this.list_commander.isEmpty() && !this.disabled && dom_elm.td_mc.childNodes.length <= 1) {
      this.renderBar(dom_elm.json.type);

      ab_current_element = dom_elm;
      AJS.ACN(dom_elm.td_mc, this.bar);
    }
  },

  addListener: function(dom_elm) {
    AJS.AEV(dom_elm, "mouseover", AJS.$p(this.appendBar, dom_elm));
  }
}


//kw can have: image, text, on_click_fn
ActionButton = function(kw) {
  this.button_json = kw;
  this.action_bar = null; //Set from bar
}

ActionButton.prototype = {
  render: function() {
    var btn = this._render();
    return btn;
  },

  _render: function() {
    var btn_class = this.button_json.btn_class || "CMS_link";

    var btn = AJS.SPAN({'class': btn_class});
    var image = null;

    if(this.button_json.image)
      image = AJS.IMG({'src': this.button_json.image});

    AJS.ACN(btn, image, AJS.TN(" "), this.button_json.text);

    var click_fn = function(e) {
      if(!this.action_bar || !this.action_bar.disabled) {
        var cur_elm = AJS.getEventElm(e);
        if(AJS.nodeName(cur_elm)=="img")
          cur_elm = cur_elm.parentNode;
        this.button_json.on_click_fn(ab_current_element, cur_elm, e);
      }
    };
    AJS.AEV(btn, "click", AJS.$b(click_fn, this));
    return btn;
  }
}
