function ListCommander(kw) {
  if(!AJS.isDefined(kw))
    alert('No arguments were suplied!');
  if(!AJS.isDefined(kw.host_table))
    alert("Argument host_table wasn't supplied");

  //Static text
  this.txt_empty = "There are no items";

  this.itemDecorator = null;
  this.items = [];

  this.action_bar = kw.action_bar;
  this.action_bar.list_commander = this;
  
  this.host_table = kw.host_table;

  this.list_separator = 666;

  //Safari fix
  this.blankIMG = function() {
    return AJS.IMG({'src': 'static_core/images/blank.gif', 'style': 'width: 5px; height: 17px;'});
  }
}

ListCommander.prototype = {

/**
  API Functions
  **/
  add: function(item_json, in_top) {
    if(this.itemDecorator)
      item_json = this.itemDecorator(item_json);
    if(in_top)
      this.items.splice(0, 0, item_json);
    else
      this.items.push(item_json);
  },

  remove: function(item_json) {
    var new_items = [];
    AJS.map(this.items, function(e) {
      if(e != item_json)
        new_items.push(e);
    });
    this.items = new_items;
    this.render();
  },

  update: function(new_item_json) {
    for(var i=0; i < this.items.length; i++) {
      if(new_item_json.id == this.items[i].id) {
        this.items[i] = new_item_json;
        break;
      }
    }
    this.render();
  },

  replace: function(item1_json, item2_json) {
    var fn = function(elm, elm_i) {
      if(elm.id == elm_i.id)
        return true;
    }
    var i = AJS.getIndex(item1_json, this.items, function(elm_i) {
      return fn(item1_json, elm_i) });
    var j = AJS.getIndex(item2_json, this.items, function(elm_i) {
      return fn(item2_json, elm_i) });

    this.items.splice(i, 1, item2_json);
    this.items.splice(j, 1, item1_json);
  },

  isEmpty: function() {
    return this.items.length == 0;
  },


/**
  Private functions
  **/
  appendElement: function(item_json) {
    var tr = AJS.TR({'class': 'lc_item'});

    var td_cnt = AJS.TD({'class': 'lc_item_cnt'}, item_json.content);
    var td_height = AJS.TD({'class': 'lc_height'}, this.blankIMG());
    var td_mc = AJS.TD({'class': 'lc_action_bar'}, this.blankIMG());

    //elm accessors
    tr.json = item_json;
    tr.td_cnt = td_cnt;
    tr.td_mc = td_mc;

    this.getActionBar().addListener(tr);

    if(this.select_able) {
        var input;
        ACN(tr, TD({s: 'width: 30px;'},
            input = INPUT({type: 'checkbox'})
        ));

        input.onclick = function() {
            if(input.checked)
              addClass(tr, 'lc_selected');
            else
              removeClass(tr, 'lc_selected')
        }
    }

    AJS.ACN(tr, td_cnt, td_height, td_mc);
    AJS.ACN(this.table, tr);
    return tr;
  },

  initTable: function() {
    if(this.table)
      AJS.removeElement(this.table);

    this.table = AJS.TBODY();
    AJS.ACN(AJS.$(this.host_table), this.table);
  },

  render: function() {
    this.initTable();

    if(this.items.length == 0) {
      this.appendElement({'content': this.txt_empty, 'class': 'Empty'});
    }
    else {
      var insert_elms = function(e) {
        this.appendElement(e);
      }
      AJS.map(this.items, AJS.$b(insert_elms, this));

      var i = 0, j = -1;
      var get_index = AJS.$b(function(elm) {
        return  AJS.getIndex(elm, this.table.childNodes, function(elm_i) {
          return elm.json.id == elm_i.json.id });
      }, this);

      if(ab_current_element) {
        j = get_index(ab_current_element);

        if(j == -1) {
          if(ab_current_element.nextSibling)
            j = get_index(ab_current_element.nextSibling);
          if(ab_current_element.previousSibling)
            j = get_index(ab_current_element.previousSibling);
        }
      }

      if(j != -1)
        i = j
      this.getActionBar().appendBar(this.table.childNodes[i]);
    }
  },

  getActionBar: function() {
    return this.action_bar;
  },

/**
  Standard buttons
  **/
  //Will send item_id to url_delete
  btnDelete: function(url_delete, image, keys, fn_callback) {
    var on_click_fn = function(elm, cur_elm) {
      if(fn_callback)
        fn_callback();

      this.getActionBar().setDisable(true);
      var really = confirm("Are you sure you want to delete?");
      if(really) {
        Indicator.append(cur_elm);

        var callback_fn = function() {
          Indicator.remove(cur_elm);
          this.getActionBar().setDisable(false);
          this.remove(elm.json);
        }
        var d = AJS.getRequest(url_delete);
        d.addCallback(AJS.$b(callback_fn, this));

        var data = {};
        if(keys) {
          keys = AJS.$A(keys);
          AJS.map(keys, function(key) {
            data[key] = elm.json[key];
          });
        }
        else {
          data['id'] = elm.json.id;
        }

        if(this.ident)
          data['ident'] = this.ident;

        d.sendReq(data);
      }
      else {
        this.getActionBar().setDisable(false);
      }
    }
    var kw = {'text': 'Delete',
              'keys': keys,
              'image': image,
              'btn_class': 'CMS_link CMS_critical_link',
              'on_click_fn': AJS.$b(on_click_fn, this)};
    return new ActionButton(kw);
  },

  btnMove: function(text, action, url_swap, image) {
    var swap_visually_fn = function(items) {
      this.replace(AJS.evalTxt(items.item1_json), 
                   AJS.evalTxt(items.item2_json));
      this.render();
    }

    var on_click_fn = function(elm) {
      var item1 = elm;

      if(action == "up")
        item2 = elm.previousSibling;
      else if(action =="down")
        item2 = elm.nextSibling;

      if(item2) {
        var item1_data = {'id': item1.json.id};
        if(item2.json.order)
          item1_data['order'] = item2.json.order;

        var item2_data = {'id': item2.json.id};
        if(item1.json.order)
          item2_data['order'] = item1.json.order;
      }
      else
        return ;

      var d = loadJSONDoc(url_swap);
      d.addCallback(AJS.$b(swap_visually_fn, this));
      var data = {'item1': serializeJSON(item1_data),
           'item2': serializeJSON(item2_data)};
      if(this.ident)
        data['ident'] = this.ident;
      d.sendReq(data);
    }
    var kw = {'text': text,
              'image': image,
              'on_click_fn': AJS.$b(on_click_fn, this)};
    return new ActionButton(kw);
  },

  btnEdit: function(text, url_edit, image, props) {
    var on_click_fn = function(elm, cur_elm) {
      this.getActionBar().setDisable(true);
      var form = AJS.FORM();

      //Submit
      var btn_submit = AJS.SPAN({'class': 'link link_critical'}, IMG({'src': 'static_core/images/save.png'}), " Save");

      var onSubmit = function(e) {
        Indicator.append(btn_submit);
        var callback_fn = function(item_json) {
          Indicator.remove(btn_submit);
          this.getActionBar().setDisable(false);
          this.update(item_json);
        };

        var errback_fn = function() {
          Indicator.remove(btn_submit);
        };

        var d = AJS.loadJSONDoc(url_edit);
        d.addCallback(AJS.$b(callback_fn, this));
        d.addErrback(AJS.$b(errback_fn, this));

        var data = {'id': elm.json.id};
        AJS.map(AJS.keys(props), function(k) {
          data[k] = AJS.$f(form, k).value;
        });

        d.sendReq(data);
        return false;
      };
      onSubmit = AJS.$b(onSubmit, this);
      AJS.AEV(btn_submit, 'mousedown', onSubmit);
      form.onsubmit = onSubmit;

      //Edit boxes
      var dl = AJS.DL();

      AJS.map(AJS.keys(props), function(k) {
        AJS.ACN(dl, AJS.DT(props[k] + ": "));
        var input = AJS.INPUT({'type': 'text', 'name': k, 'value': elm.json[k]})
        AJS.ACN(dl, AJS.DD(input));
      });
      AJS.ACN(dl, btn_submit);

      AJS.ACN(form, dl);

      AJS.RCN(elm.td_cnt, form);
    }

    var kw = {'text': text,
              'btn_class': 'CMS_link CMS_action_link',
              'image': image,
              'on_click_fn': AJS.$b(on_click_fn, this)};
    return new ActionButton(kw);
  }
}

ListCommander.btnDelete = ListCommander.prototype.btnDelete;
ListCommander.btnEdit = ListCommander.prototype.btnEdit;
ListCommander.btnMove = ListCommander.prototype.btnMove;
