/**
  Tooltip (AmiTooltip)
  **/
AJS.AEV(window, "load", AmiTooltip.init);
if(!PageOracle)
  var PageOracle = parent.parent.PageOracle;


/**
  Toolbar (AmiBar)
  **/
function createToolbar() {
  var amibar = new AmiBar("static_core/amibar/");

  var decorateButton = function(button, itext, htext, etext) {
    if(itext) {
      var button_onclick = function() { 
        AmiFormat.insertAtCursor(AJS.$("cms_ta"), itext, false, true); 
        AmiTooltip.hide();
      };
      button.setOnClick(button_onclick);
    }
    button.setOnMouseOver( function(e) {AmiTooltip.show(e, htext, etext);} );
    button.setOnMouseOut(AmiTooltip.hide);
  };

  //Bold button
  var bold = new AmiBarButton("bold", "bold.png");
  decorateButton(bold, "%(b) ~%", "Insert bold text");

  //Italic button
  var italic = new AmiBarButton("italic", "italic.png");
  decorateButton(italic, "%(i) ~%", "Insert italic text");

  //Underline button
  var underline = new AmiBarButton("underline", "underline.png");
  decorateButton(underline, "%(u) ~%", "Insert underline text");

  //Image button
  var img = new AmiBarButton("image", "image.png");
  decorateButton(img, "[image=~]", "Insert an image", "When you save you will be able to upload.");

  //File button
  var file = new AmiBarButton("file", "file.png");
  decorateButton(file, "[file=~]", "Insert a file", "When you save you will be able to upload.");

  //Page button
  var page = new AmiBarButton("page", "page.png");
  decorateButton(page, "[page=~]", "Insert an under-page", "When you save you will be able to create the specified page.");

  //Page link
  var plink = new AmiBarButton("page_link", "page_link.png");
  decorateButton(plink, "[pagelink=~]", "Insert a page link", "Links to an internal page.<br />You specify the text you would like the link to have.");

  //Link button
  var link = new AmiBarButton("link", "link.png");
  decorateButton(link, '"~":()', "Insert an external link", 'The syntax is "Text":(http://am.com/)');

  //Image link
  var ilink = new AmiBarButton("image_link", "image_link.png");
  decorateButton(ilink, '!~ ()!', "Insert an external image", 'The syntax is !http://link.com (Alt text)!');

  //Component
  var component_add = new AmiBarButton("image_link", "component_add.png");
  decorateButton(component_add, null, "Add plugin syntax", "This will open a GreyBox window that will guide your through.");
  component_add.setOnClick(function() {
    EC_Editor.savePosition();
    return GB_showFullScreen("Add plugin syntax", PageOracle.getBaseURL() + "/pages/viewInsertPlugin");
  });

  amibar.appendButton(bold);
  amibar.appendButton(italic);
  amibar.appendButton(underline);
  amibar.appendSeparator();
  amibar.appendButton(img);
  amibar.appendButton(file);
  amibar.appendButton(page);
  amibar.appendButton(plink);
  amibar.appendSeparator();
  amibar.appendButton(link);
  amibar.appendButton(ilink);
  amibar.appendSeparator();
  amibar.appendButton(component_add);
  return amibar;
}
if(typeof(AmiBar) != 'undefined') {
    var AMIBAR = createToolbar();
}


/**
  GoogieSpell
  **/
try{
  var GOOGIESPELL = new GoogieSpell("static_core/googiespell/", "spellchecker/?lang=");
  GOOGIESPELL.show_spell_img = false;
  GOOGIESPELL.change_lang_pic_placement = "right";
  var langs = {"da": "Danish", "en": "English"};
  GOOGIESPELL.setLanguages(langs);
}
catch(e) {
}

/**
 Windows
 **/
function showProperties() {
  var url = PageOracle.getBaseURL() + "/pages/showPageProperties?page_id=" + PageOracle.getPageId();
  GB_show("Page properties", url, 500, 650);
  return false;
}

function showPageLog() {
  var url = PageOracle.getBaseURL() + "/pages/showPageLog?page_id=" + PageOracle.getPageId();
  GB_showFullScreen("Page log", url);
  return false;
}


/**
  Content controller
  **/
var EC_Content = {
      changeContentVisual: function(new_val) {
        if(new_val == "")
          new_val = 'The page has no content';

        var content_text = $('CMS_ContentText');
        content_text.innerHTML = '<span class="Content">' + new_val + '</span>';
        EC_Content.decoratePageElements();
      },

      resumeEditing: function(elm) {
        if(elm)
          Indicator.append(elm);
        var fn = function(res_txt) {
          if(elm)
            Indicator.remove(elm);
          EC_Content.changeContentVisual(res_txt);
        };
        EC_Content.fetchContentRendered(fn);
      },

  //
  // Callbacks
  //
  changeContentOnSubmit: function(new_val, btn_submit) {
    Indicator.append(btn_submit);
    
    var d = AJS.getRequest('pages/setContent');
    d.addCallback( function (res_txt) {
      Indicator.remove(btn_submit);
      EC_Content.changeContentVisual(res_txt);
      AJS.evalScriptTags(res_txt);
    });

    d.sendReq({'page_id': PageOracle.getPageId(), 'new_val': new_val});
    return false;
  },

  fetchContentRaw: function(callback_fn) {
    var d = AJS.getRequest('pages/getContent');
    d.addCallback(callback_fn);
    d.sendReq({'page_id': PageOracle.getPageId()});
  },

  fetchContentRendered: function(callback_fn) {
    var d = AJS.getRequest('pages/getContent');
    d.addCallback(callback_fn);
    d.sendReq({'page_id': PageOracle.getPageId(), 'no_json': 0});
  },

  setContent: function(res_txt) {
    var content_text = $('CMS_ContentText');
    var gen_form = EC_Editor.createEditBox(EC_Content.changeContentOnSubmit, res_txt, true);
    
    AJS.RCN(content_text, gen_form['form']);
    EC_Editor.restorePosition();
  },

  decoratePageElements: function() {
    var content_text = $('CMS_ContentText');
    if(content_text) {
    var span_content_text = AJS.$bytc(null, "Content", content_text)[0].innerHTML; //SPAN obj

    var btn_change_content = SPAN({'class': 'CMS_link'}, IMG({'src': 'static_core/images/page_edit.png'}), "Edit content");

    var btn_mode = EditModeButton.getButton();

    var btn_admin = SPAN({'class': 'CMS_link'}, IMG({'src': 'static_core/images/admin.gif'}, null), "Admin");
    btn_admin.onclick = function() { return showAdmin(''); };

    var btn_page_pro = SPAN({'class': 'CMS_link'}, IMG({'src': 'static_core/images/properties.gif'}, null), "Properties");
    btn_page_pro.onclick = function() { return showProperties(); };

    var btn_log = SPAN({'class': 'CMS_link'}, IMG({'src': 'static_core/images/log.png'}, null), "Page log");
    btn_log.onclick = function() { return showPageLog(); };

    var div_change_content = DIV({'class': 'action', 'id': 'CMS_PageBar'});
    div_change_content.style.width = "98%";

    var div_r = AJS.DIV({'style': 'float: right'});
    AJS.ACN(div_r, btn_log);
    if(PageOracle.isAdmin())
      AJS.ACN(div_r, " ", btn_admin);

    var div_l = AJS.DIV(btn_change_content, " ", btn_page_pro, " ", btn_mode);
    AJS.ACN(div_change_content, div_r, div_l);

    btn_change_content.onclick = function () {
      Indicator.append(btn_change_content);
      EC_Content.fetchContentRaw(EC_Content.setContent);
    };

    AJS.RCN(content_text, div_change_content);
    var new_span = AJS.setHTML(AJS.SPAN({'class': 'Content'}), span_content_text);
    AJS.ACN(content_text, new_span);
    }
  }

}
if(PageOracle.hasEditPermission() && PageOracle.isCmsPage())
  AJS.AEV(window, "load", EC_Content.decoratePageElements);


/**
  Functions that the page editor uses
  **/
var EC_Editor = {
  init: function() {
    this.cur_place = 0;
    this.scroll_top = 0;
  },

  getCurrentTextfield: function() {
    return $('cms_ta');
  },

  getLastCurPostion: function() {
    return this.cur_place;
  },

  restorePosition: function() {
    var elm = this.getCurrentTextfield();
    elm.scrollTop = this.scroll_top;
    AmiFormat.placeCursor(elm, this.cur_place);
  },

  savePosition: function(on_save) {
    var elm = AJS.$('cms_ta');
    if(elm && GOOGIESPELL.state == "spell_check") {
      AmiFormat.insertAtCursor(elm, "~!!dum42my!!", true);

      this.cur_place = elm.value.indexOf("!!dum42my!!");
      this.scroll_top = elm.scrollTop;

      //Stupid IE
      if(document.selection) {
        var val = elm.value.slice(0, this.cur_place);
        this.cur_place -= val.split("\n").length - 1;
      }
      elm.value = elm.value.replace("!!dum42my!!", "");
    }
  },

  openHelpWin: function() {
    GB_show("Syntax help", PageOracle.getBaseURL() + '/syntax_help/', 500, 670); 
  },

  //GOOGIESPELL and AMIBAR are defined in skeletonz/scripts/general/init.js
  createEditBox: function(submit_function, input_value, textarea) {
    var form = AJS.FORM({'class': 'edit_form'});

    var img_save = IMG({'src': 'static_core/images/save.png'});
    var btn_submit = SPAN({'class': 'CMS_link CMS_critical_link'}, img_save, ' ', "Save change");

    if(textarea) {
      var img_help = IMG({'src': 'static_core/images/help.png'});

      var btn_help = SPAN({'class': 'CMS_link'}, img_help, "Syntax help");
      btn_help.onclick = function () {
        EC_Editor.openHelpWin();
      };

      var btn_cancle = SPAN({'class': 'cancle_link'}, "Cancel");
      btn_cancle.onclick = function() { EC_Editor.savePosition(); EC_Content.resumeEditing(btn_cancle); };

      var div_submit = DIV({'class': 'action'}, btn_submit, " ", btn_help, " ", btn_cancle);
      div_submit.style.width = "98%";

      var input = TEXTAREA({'class': 'edit_textarea', 'id': 'cms_ta'}, input_value);
      
      form.appendChild(div_submit);
      
      //Create the toolbar + spellcheck table
      var toolbar_div = DIV({'style': 'width: 98%; padding-top: 8px; padding-bottom: 5px;'});
      var spell_check = DIV({'style': 'float: right'});
      var toolbar = DIV();
      AJS.ACN(toolbar_div, spell_check, toolbar);

      AMIBAR.setToolbarContainer(toolbar);
      AMIBAR.populateDiv();

      AJS.ACN(form, toolbar_div, input);

      //IE bug fix - argh
      input.style.width = "98%";

      GOOGIESPELL.setForceWidthHeight("97%", null)
      GOOGIESPELL.setSpellContainer(spell_check);
      GOOGIESPELL.decorateTextarea(input);
    }
    else {
      var input = INPUT({'type': 'input', 'value': input_value, 'class': 'edit_input',
      'style': 'margin-right: 8px;'});
      AJS.ACN(form, input, btn_submit);
    }

    btn_submit.onclick = function () {
      AmiTooltip.hide();
      EC_Editor.savePosition();
      submit_function(input.value, btn_submit) 
    };
    form.onsubmit = function () { 
      return submit_function(input.value, btn_submit) 
    };
    return {'form': form, 'input': input};
  }
}
EC_Editor.init();

var EditModeButton = {
  _getImg: function(state) {
    var img = IMG({'src': 'static_core/images/'+ state +'.png'});
    return img;
  },

  _getState: function() {
    return PageOracle.getViewEditMode();
  },

  _inverse: function(val) {
    if(val == "on")
      return "off";
    else
      return "on";
  },

  getButton: function() {
    var state = EditModeButton._getState();
    var img = EditModeButton._getImg( state );
    var btn = SPAN({'class': 'CMS_link'}, img , "Edit mode");

    btn.state = state;
    btn.img = img;

    AJS.AEV(btn, "click", EditModeButton.switchState);
    return btn;
  },

  switchState: function(e) {
    var elm = AJS.getEventElm(e);
    if(AJS.nodeName(elm) == "img")
      elm = elm.parentNode;

    var state = EditModeButton._inverse(elm.state);

    Indicator.append(elm);

    elm.state = state;
    PageOracle.view_edit_mode = state;

    var d = AJS.getRequest('siteedit/setViewEditMode');

    var fn = function(res_txt) {
      Indicator.remove(elm);
      AJS.RCN(elm, EditModeButton._getImg(state), "View edit");
      EC_Content.changeContentVisual(res_txt);
    };

    d.addCallback(fn);
    d.sendReq({'value': state, 'page_id': PageOracle.getPageId()});
  }

}
