/**
    Headline controller
    **/
var EC_Headline = {
    onSubmit: function(new_val, btn_submit) {
        Indicator.append(btn_submit);

        //Ajax update
        var d = AJS.getRequest('pages/setTitle');

        d.addCallback( function () {
            Indicator.remove(btn_submit);

            //Visual
            var headline = AJS.$('CMS_HeadLine');
            AJS.RCN(headline, new_val);
            EC_Headline.decoratePageElements();

            //Update nav
            var nav_current = $('CMS_NavCurrentPage');
            if(nav_current)
                nav_current.innerHTML = new_val;
        });

        var data = {'page_id': PageOracle.getPageId(), 'new_val': new_val};
        d.sendReq({'data': AJS.serializeJSON(data)});
        return false;
    },

    unEntify: function(val) {
        var fn = function(w, g) {
            switch(g) {
                case '&amp;':
                    return '&';
                case '&lt;':
                    return '<';
                case '&gt;':
                    return '>';
            }
        }
        return val.replace(/(&amp;|&lt;|&gt;)/g, fn);
    },

    decoratePageElements: function() {
        var headline = AJS.$("CMS_HeadLine");
        if(headline) {
            var headline_value = EC_Headline.unEntify(headline.innerHTML);
            var btn_change_headline = SPAN({'class': 'CMS_link'},
                    IMG({'alt': 'Edit', 'src': 'static_core/images/edit.png'}, null), "Edit page headline");

            btn_change_headline.onclick = function () {
                var gen_form = EC_Editor.createEditBox(EC_Headline.onSubmit, headline_value);
                AJS.RCN(headline, gen_form['form']);
                gen_form['input'].select();
                if(window.GB_P)
                        GB_P.GB_CURRENT.reload_on_close = true;
            };
            headline.appendChild(SPAN(" ", btn_change_headline));
        }
    }
}
if(PageOracle.hasEditPermission())
    AJS.AEV(window, "load", EC_Headline.decoratePageElements);
