import sys, os

from skeletonz.model.UserModel import Users, Groups
from skeletonz.model.CMSModel import MenuItems, Menus, Pages

import general_config

from amilib.amiweb import amiweb
amiweb.setUpDatabase(general_config.DB_HOST, general_config.DB_USER, general_config.DB_PASSWORD, general_config.DB_DATABASE, general_config.TABLE_PREFIX)

amiweb.setUpConnection()

def test_pool():
    assert amiweb.db_pool.getSize() == 5

    #Test that the pool gets smaller
    connections = []
    for i in range(0, 5):
        connections.append(amiweb.db_pool.getConnection())
    assert amiweb.db_pool.getSize() == 0

    #Test that connections can get back into the pool
    map(amiweb.db_pool.releaseConnection, connections)
    assert amiweb.db_pool.getSize() == 5

    #Test that the connections in the pool are equal to the first ones
    #i.e. connections should be reused
    new_connections = []
    for i in range(0, 5):
        new_connections.append(amiweb.db_pool.getConnection())
    assert new_connections == connections

    #The pool is empty, a new connection should be returned
    assert amiweb.db_pool.getSize() == 0
    con = amiweb.db_pool.getConnection()
    assert con != None
    assert con not in new_connections
    #Put this connection back in
    amiweb.db_pool.releaseConnection(con)
    assert amiweb.db_pool.getSize() == 1

    #Put the new_connections back in and except the pool size to be size 5
    #The last connection should be closed
    map(amiweb.db_pool.releaseConnection, new_connections[:4])
    assert amiweb.db_pool.getSize() == 5

    #The last is the magic number
    con_last = new_connections[-1]
    assert con_last.is_closed == False
    amiweb.db_pool.releaseConnection(con_last)
    assert con_last.is_closed == True
    assert amiweb.db_pool.getSize() == 5
