import sys, os
sys.path.insert(0, os.path.abspath(""))
sys.path.insert(0, os.path.abspath("lib"))
sys.path.insert(0, os.path.abspath("skeletonz"))

from skeletonz.model.CMSModel import Files
import skeletonz.model.CMSModel as CMSModel

import general_config

from amiweb import amiweb
amiweb.setUpDatabase(general_config.DB_HOST, general_config.DB_USER, general_config.DB_PASSWORD, general_config.DB_DATABASE, general_config.TABLE_PREFIX)

amiweb.setUpConnection()

def setup_module(module):
    CMSModel.upload_dir = "uploads_test"
    os.mkdir("uploads_test")

def test_creation():
    assert Files.notCreated("test.png") == True
    #Create it
    f = Files.uploadFile("Test billede", "test.png", "png", "blafakjgajk424j2h")
    assert Files.notCreated("test.png") == False

def test_getFileById():
    assert Files.notCreated("test.png") == False
    f = Files.getFileById(Files.getFileByIdent("Test billede", "png").id)
    assert f != None

def test_deleteFileById():
    assert Files.notCreated("test.png") == False
    Files.deleteFileById(Files.getFileByIdent("Test billede", "png").id)
    assert Files.notCreated("test.png") == True

def test_uploadFile():
    assert Files.notCreated("test.png") == True
    file_upload = Files.uploadFile("Test billede", "test.png", "png", "blafakjgajk424j2h")

def test_os_file():
    os_filename = "%s/%s" % (Files._getFullPath(), "test.png")
    fp = open(os_filename)
    assert fp.readline() == "blafakjgajk424j2h"

def test_edit():
    f_id = Files.getFileByIdent("Test billede", "png").id

    #file_new
    file_upload = Files.uploadFileEdit(f_id, "test_new.png", "png", "blahblah")

    assert Files.notCreated("test.png") == True
    assert Files.notCreated("test_new.png") == False

    file_upload = Files.uploadFileEdit(f_id, "test_new_another.txt", "txt", "buububub")
    assert Files.notCreated("test_new.png") == True
    assert Files.notCreated("test_new_another.txt") == False

def test_insert_same_filename():
    file_upload = Files.uploadFile("Test billede1", "test_new.png", "png", "blafakjgajk424j2h")
    file_upload = Files.uploadFile("Test billede2", "test_new.png", "png", "blafakjgajk424j2h")
    file_upload = Files.uploadFile("Test billede3", "test", "png", "blafakjgajk424j2h")
    file_upload = Files.uploadFile("Test billede4", "test", "png", "blafakjgajk424j2h")

    assert Files.getFileByIdent("Test billede1", "png").ident == "Test billede1"
    assert Files.getFileByIdent("Test billede2", "png") != None
    assert Files.getFileByIdent("Test billede3", "png") != None
    assert Files.getFileByIdent("Test billede4", "png") != None

    #Filesnames
    assert Files.getFileByIdent("Test billede2", "png").filename == "test_new3.png"
    assert Files.getFileByIdent("Test billede4", "png").filename == "test3"

def teardown_module(module):
    #Delete all uploaded files
    Files.deleteFileById(Files.getFileByIdent("Test billede", "txt").id)
    Files.deleteFileById(Files.getFileByIdent("Test billede1", "png").id)
    Files.deleteFileById(Files.getFileByIdent("Test billede2", "png").id)
    Files.deleteFileById(Files.getFileByIdent("Test billede3", "png").id)
    Files.deleteFileById(Files.getFileByIdent("Test billede4", "png").id)
    os.popen("rm -rf uploads_test")
