import sys, os
sys.path.insert(0, os.path.abspath(""))

from mylib.splitter import *

def test_one_keyword():
    text = """[add,s=cow, d=blah]"""
    def re_cow(args, edit_mode, page):
        return args['s']
    assert splitter(text, [('add', re_cow)], False) == "cow"

def test_two():
    text = """[add, n1=2, n2=3]"""
    def re_cow(args, edit_mode, page):
        return int(args['n1']) + int(args['n2'])
    assert splitter(text, [('add', re_cow)], False) == "5"

def test_three():
    text = """[a href]"""
    def re_cow(args, edit_mode, page):
        return '<a href="">Hello</a>'
    assert splitter(text, [('a href', re_cow)], False) == '<a href="">Hello</a>'

def test_f():
    text = """[a href, aslink]"""
    def re_cow(args, edit_mode, page):
        return '<a href="" asLinkos>Hello</a>'
    assert splitter(text, [('a href', re_cow)], False) == '<a href="" asLinkos>Hello</a>'

def test_a():
    text = """[page=Hello]"""
    def re_cow(args, edit_mode, page):
        return 'page %s' % args['page']
    assert splitter(text, [('page', re_cow)], False) == 'page Hello'
