import sys, os
sys.path.insert(0, os.path.abspath(""))
sys.path.insert(0, os.path.abspath("lib"))
sys.path.insert(0, os.path.abspath("skeletonz"))

from skeletonz.model import CMSModel
from skeletonz.plugins.personneltable.Tables import *

import general_config

from amiweb import amiweb
amiweb.setUpDatabase(general_config.DB_HOST, general_config.DB_USER, general_config.DB_PASSWORD, general_config.DB_DATABASE, general_config.TABLE_PREFIX)

amiweb.setUpConnection()

gid = {}

def test_create_table():
    first = Tables.insertTable("Mooh 1 2 3 Bl bh")
    assert first != None

    second = Tables.insertTable("Mooh 1 2 3 Bl bh")
    assert second == None
    gid["first"] = first.id

def test_insert_items():
    first_item = TableItems.insertItem(gid['first'], "{'name': 'blah'}", 1)
    assert first_item != None
    assert len(Tables.getTableById(gid['first']).getAllItems()) > 0

    TableItems.setNewOrder(first_item.id, 10)
    assert TableItems.getItemById(first_item.id).item_order == 10

    TableItems.updateData(first_item.id, "Hej dette er dsfkjdfdsflkj")
    assert TableItems.getItemById(first_item.id).json_data == "Hej dette er dsfkjdfdsflkj"

def teardown_module(module):
    Tables.deleteTable(gid['first'])
