import sys, os
sys.path.insert(0, os.path.abspath(""))

from model.UserModel import *
from model import database

def setup_module(module):
    database.sql_connect(0)
    if User.sqlmeta.table != 'test_user':
        raise Exception("Table is not test table!!")

    try:
        User.dropTable(ifExists=True)
    except:
        pass
    User.createTable(ifNotExists=True)

def test_insert_users():
    Users.addUser("amix", "amix")
    Users.addUser("gorm", "dengamle")
    Users.addUser("fido", "erjegenhund")

def test_get_all_users():
    assert Users.getAllUsers().count() == 3

def testJSON():
    amix = Users.getUserById(1)
    assert '{"id": 1, "name": "amix"}' == amix.toJSON()

def testDeleteUser():
    Users.deleteUser(2)
    assert Users.getAllUsers().count() == 2

def teardown_module(module):
    try:
        User.dropTable()
    except:
        pass
